// ************************************************************************ //
// The types declared in this file were generated from data read from the
// WSDL File described below:
// WSDL     : http://api.pro6pp.nl/v1/soap/api.wsdl
//  >Import : http://api.pro6pp.nl/v1/soap/api.wsdl>0
// Encoding : UTF-8
// Version  : 1.0
// (11/16/2011 3:33:10 PM - - $Rev: 34800 $)
// ************************************************************************ //

unit api;

interface

uses InvokeRegistry, SOAPHTTPClient, Types, XSBuiltIns;

const
  IS_OPTN = $0001;
  IS_UNBD = $0002;
  IS_NLBL = $0004;
  IS_REF  = $0080;


type

  // ************************************************************************ //
  // The following types, referred to in the WSDL document are not being represented
  // in this file. They are either aliases[@] of other types represented or were referred
  // to but never[!] declared in the document. The types from the latter category
  // typically map to predefined/known XML or Embarcadero types; however, they could also 
  // indicate incorrect WSDL documents that failed to declare or import a schema type.
  // ************************************************************************ //
  // !:int             - "http://www.w3.org/2001/XMLSchema"[Gbl]
  // !:string          - "http://www.w3.org/2001/XMLSchema"[Gbl]
  // !:decimal         - "http://www.w3.org/2001/XMLSchema"[Gbl]

  FeedbackResult       = class;                 { "http://api.pro6pp.nl/v1/soap/api.wsdl"[GblCplx] }
  feedbackResponse     = class;                 { "http://api.pro6pp.nl/v1/soap/api.wsdl"[Lit][GblElm] }
  feedbackRequest      = class;                 { "http://api.pro6pp.nl/v1/soap/api.wsdl"[Lit][GblElm] }
  rangeRequest         = class;                 { "http://api.pro6pp.nl/v1/soap/api.wsdl"[Lit][GblElm] }
  autocompleteRequest  = class;                 { "http://api.pro6pp.nl/v1/soap/api.wsdl"[Lit][GblElm] }
  Address              = class;                 { "http://api.pro6pp.nl/v1/soap/api.wsdl"[GblCplx] }
  autocompleteResponse = class;                 { "http://api.pro6pp.nl/v1/soap/api.wsdl"[Lit][GblElm] }
  RangeResult          = class;                 { "http://api.pro6pp.nl/v1/soap/api.wsdl"[GblCplx] }
  rangeResponse        = class;                 { "http://api.pro6pp.nl/v1/soap/api.wsdl"[Lit][GblElm] }



  // ************************************************************************ //
  // XML       : FeedbackResult, global, <complexType>
  // Namespace : http://api.pro6pp.nl/v1/soap/api.wsdl
  // ************************************************************************ //
  FeedbackResult = class(TRemotable)
  private
  published
  end;

  FeedbackResults = array of FeedbackResult;    { "http://api.pro6pp.nl/v1/soap/api.wsdl"[GblCplx] }


  // ************************************************************************ //
  // XML       : feedbackResponse, global, <element>
  // Namespace : http://api.pro6pp.nl/v1/soap/api.wsdl
  // Serializtn: [xoLiteralParam]
  // Info      : Wrapper
  // ************************************************************************ //
  feedbackResponse = class(TRemotable)
  private
    Fresults: FeedbackResults;
  public
    constructor Create; override;
    destructor Destroy; override;
  published
    property results: FeedbackResults  read Fresults write Fresults;
  end;



  // ************************************************************************ //
  // XML       : feedbackRequest, global, <element>
  // Namespace : http://api.pro6pp.nl/v1/soap/api.wsdl
  // Serializtn: [xoLiteralParam]
  // Info      : Wrapper
  // ************************************************************************ //
  feedbackRequest = class(TRemotable)
  private
    Fauth_key: string;
    Fnl_sixpp: string;
    Fstreet: string;
  public
    constructor Create; override;
  published
    property auth_key: string  read Fauth_key write Fauth_key;
    property nl_sixpp: string  read Fnl_sixpp write Fnl_sixpp;
    property street:   string  read Fstreet write Fstreet;
  end;



  // ************************************************************************ //
  // XML       : rangeRequest, global, <element>
  // Namespace : http://api.pro6pp.nl/v1/soap/api.wsdl
  // Serializtn: [xoLiteralParam]
  // Info      : Wrapper
  // ************************************************************************ //
  rangeRequest = class(TRemotable)
  private
    Fauth_key: string;
    Fnl_fourpp: Integer;
    Frange: Integer;
    Frange_Specified: boolean;
    Fper_page: Integer;
    Fper_page_Specified: boolean;
    procedure Setrange(Index: Integer; const AInteger: Integer);
    function  range_Specified(Index: Integer): boolean;
    procedure Setper_page(Index: Integer; const AInteger: Integer);
    function  per_page_Specified(Index: Integer): boolean;
  public
    constructor Create; override;
  published
    property auth_key:  string   read Fauth_key write Fauth_key;
    property nl_fourpp: Integer  read Fnl_fourpp write Fnl_fourpp;
    property range:     Integer  Index (IS_OPTN) read Frange write Setrange stored range_Specified;
    property per_page:  Integer  Index (IS_OPTN) read Fper_page write Setper_page stored per_page_Specified;
  end;



  // ************************************************************************ //
  // XML       : autocompleteRequest, global, <element>
  // Namespace : http://api.pro6pp.nl/v1/soap/api.wsdl
  // Serializtn: [xoLiteralParam]
  // Info      : Wrapper
  // ************************************************************************ //
  autocompleteRequest = class(TRemotable)
  private
    Fauth_key: string;
    Fnl_sixpp: string;
    Fnl_sixpp_Specified: boolean;
    Fnl_fourpp: Integer;
    Fnl_fourpp_Specified: boolean;
    Fstreetnumber: string;
    Fstreetnumber_Specified: boolean;
    procedure Setnl_sixpp(Index: Integer; const Astring: string);
    function  nl_sixpp_Specified(Index: Integer): boolean;
    procedure Setnl_fourpp(Index: Integer; const AInteger: Integer);
    function  nl_fourpp_Specified(Index: Integer): boolean;
    procedure Setstreetnumber(Index: Integer; const Astring: string);
    function  streetnumber_Specified(Index: Integer): boolean;
  public
    constructor Create; override;
  published
    property auth_key:     string   read Fauth_key write Fauth_key;
    property nl_sixpp:     string   Index (IS_OPTN) read Fnl_sixpp write Setnl_sixpp stored nl_sixpp_Specified;
    property nl_fourpp:    Integer  Index (IS_OPTN) read Fnl_fourpp write Setnl_fourpp stored nl_fourpp_Specified;
    property streetnumber: string   Index (IS_OPTN) read Fstreetnumber write Setstreetnumber stored streetnumber_Specified;
  end;



  // ************************************************************************ //
  // XML       : Address, global, <complexType>
  // Namespace : http://api.pro6pp.nl/v1/soap/api.wsdl
  // ************************************************************************ //
  Address = class(TRemotable)
  private
    Fnl_sixpp: string;
    Fnl_sixpp_Specified: boolean;
    Fnl_fourpp: Integer;
    Fnl_fourpp_Specified: boolean;
    Fstreet: string;
    Fstreet_Specified: boolean;
    Fcity: string;
    Fmunicipality: string;
    Fprovince: string;
    Flat: string;
    Flat_Specified: boolean;
    Flng: string;
    Flng_Specified: boolean;
    Fareacode: string;
    Fareacode_Specified: boolean;
    procedure Setnl_sixpp(Index: Integer; const Astring: string);
    function  nl_sixpp_Specified(Index: Integer): boolean;
    procedure Setnl_fourpp(Index: Integer; const AInteger: Integer);
    function  nl_fourpp_Specified(Index: Integer): boolean;
    procedure Setstreet(Index: Integer; const Astring: string);
    function  street_Specified(Index: Integer): boolean;
    procedure Setlat(Index: Integer; const Astring: string);
    function  lat_Specified(Index: Integer): boolean;
    procedure Setlng(Index: Integer; const Astring: string);
    function  lng_Specified(Index: Integer): boolean;
    procedure Setareacode(Index: Integer; const Astring: string);
    function  areacode_Specified(Index: Integer): boolean;
  published
    property nl_sixpp:     string   Index (IS_OPTN) read Fnl_sixpp write Setnl_sixpp stored nl_sixpp_Specified;
    property nl_fourpp:    Integer  Index (IS_OPTN) read Fnl_fourpp write Setnl_fourpp stored nl_fourpp_Specified;
    property street:       string   Index (IS_OPTN) read Fstreet write Setstreet stored street_Specified;
    property city:         string   read Fcity write Fcity;
    property municipality: string   read Fmunicipality write Fmunicipality;
    property province:     string   read Fprovince write Fprovince;
    property lat:          string   Index (IS_OPTN) read Flat write Setlat stored lat_Specified;
    property lng:          string   Index (IS_OPTN) read Flng write Setlng stored lng_Specified;
    property areacode:     string   Index (IS_OPTN) read Fareacode write Setareacode stored areacode_Specified;
  end;

  Results    = array of Address;                { "http://api.pro6pp.nl/v1/soap/api.wsdl"[GblCplx] }


  // ************************************************************************ //
  // XML       : autocompleteResponse, global, <element>
  // Namespace : http://api.pro6pp.nl/v1/soap/api.wsdl
  // Serializtn: [xoLiteralParam]
  // Info      : Wrapper
  // ************************************************************************ //
  autocompleteResponse = class(TRemotable)
  private
    Fresults: Results;
  public
    constructor Create; override;
    destructor Destroy; override;
  published
    property results: Results  read Fresults write Fresults;
  end;



  // ************************************************************************ //
  // XML       : RangeResult, global, <complexType>
  // Namespace : http://api.pro6pp.nl/v1/soap/api.wsdl
  // ************************************************************************ //
  RangeResult = class(TRemotable)
  private
    Fnl_fourpp: Integer;
    Flat: TXSDecimal;
    Flng: TXSDecimal;
  public
    destructor Destroy; override;
  published
    property nl_fourpp: Integer     read Fnl_fourpp write Fnl_fourpp;
    property lat:       TXSDecimal  read Flat write Flat;
    property lng:       TXSDecimal  read Flng write Flng;
  end;

  RangeResults = array of RangeResult;          { "http://api.pro6pp.nl/v1/soap/api.wsdl"[GblCplx] }


  // ************************************************************************ //
  // XML       : rangeResponse, global, <element>
  // Namespace : http://api.pro6pp.nl/v1/soap/api.wsdl
  // Serializtn: [xoLiteralParam]
  // Info      : Wrapper
  // ************************************************************************ //
  rangeResponse = class(TRemotable)
  private
    Fresults: RangeResults;
  public
    constructor Create; override;
    destructor Destroy; override;
  published
    property results: RangeResults  read Fresults write Fresults;
  end;


  // ************************************************************************ //
  // Namespace : http://api.pro6pp.nl/v1/soap/api.wsdl
  // soapAction: http://api.pro6pp.nl/v1/%operationName%
  // transport : http://schemas.xmlsoap.org/soap/http
  // style     : document
  // use       : literal
  // binding   : Pro6PP_Binding
  // service   : Pro6PP
  // port      : Pro6PP_Port
  // URL       : http://api.pro6pp.nl/v1/soap
  // ************************************************************************ //
  Pro6PP_Port = interface(IInvokable)
  ['{06970B3F-17B7-9E25-AFEA-F79F4F4C8BC2}']

    // Cannot unwrap: 
    //     - Input element wrapper name does not match operation's name
    function  autocomplete(const parameters: autocompleteRequest): autocompleteResponse; stdcall;

    // Cannot unwrap: 
    //     - Input element wrapper name does not match operation's name
    function  range(const parameters: rangeRequest): rangeResponse; stdcall;

    // Cannot unwrap: 
    //     - Input element wrapper name does not match operation's name
    function  feedback(const parameters: feedbackRequest): feedbackResponse; stdcall;
  end;

function GetPro6PP_Port(UseWSDL: Boolean=System.False; Addr: string=''; HTTPRIO: THTTPRIO = nil): Pro6PP_Port;


implementation
  uses SysUtils;

function GetPro6PP_Port(UseWSDL: Boolean; Addr: string; HTTPRIO: THTTPRIO): Pro6PP_Port;
const
  defWSDL = 'http://api.pro6pp.nl/v1/soap/api.wsdl';
  defURL  = 'http://api.pro6pp.nl/v1/soap';
  defSvc  = 'Pro6PP';
  defPrt  = 'Pro6PP_Port';
var
  RIO: THTTPRIO;
begin
  Result := nil;
  if (Addr = '') then
  begin
    if UseWSDL then
      Addr := defWSDL
    else
      Addr := defURL;
  end;
  if HTTPRIO = nil then
    RIO := THTTPRIO.Create(nil)
  else
    RIO := HTTPRIO;
  try
    Result := (RIO as Pro6PP_Port);
    if UseWSDL then
    begin
      RIO.WSDLLocation := Addr;
      RIO.Service := defSvc;
      RIO.Port := defPrt;
    end else
      RIO.URL := Addr;
  finally
    if (Result = nil) and (HTTPRIO = nil) then
      RIO.Free;
  end;
end;


constructor feedbackResponse.Create;
begin
  inherited Create;
  FSerializationOptions := [xoLiteralParam];
end;

destructor feedbackResponse.Destroy;
var
  I: Integer;
begin
  for I := 0 to System.Length(Fresults)-1 do
    SysUtils.FreeAndNil(Fresults[I]);
  System.SetLength(Fresults, 0);
  inherited Destroy;
end;

constructor feedbackRequest.Create;
begin
  inherited Create;
  FSerializationOptions := [xoLiteralParam];
end;

constructor rangeRequest.Create;
begin
  inherited Create;
  FSerializationOptions := [xoLiteralParam];
end;

procedure rangeRequest.Setrange(Index: Integer; const AInteger: Integer);
begin
  Frange := AInteger;
  Frange_Specified := True;
end;

function rangeRequest.range_Specified(Index: Integer): boolean;
begin
  Result := Frange_Specified;
end;

procedure rangeRequest.Setper_page(Index: Integer; const AInteger: Integer);
begin
  Fper_page := AInteger;
  Fper_page_Specified := True;
end;

function rangeRequest.per_page_Specified(Index: Integer): boolean;
begin
  Result := Fper_page_Specified;
end;

constructor autocompleteRequest.Create;
begin
  inherited Create;
  FSerializationOptions := [xoLiteralParam];
end;

procedure autocompleteRequest.Setnl_sixpp(Index: Integer; const Astring: string);
begin
  Fnl_sixpp := Astring;
  Fnl_sixpp_Specified := True;
end;

function autocompleteRequest.nl_sixpp_Specified(Index: Integer): boolean;
begin
  Result := Fnl_sixpp_Specified;
end;

procedure autocompleteRequest.Setnl_fourpp(Index: Integer; const AInteger: Integer);
begin
  Fnl_fourpp := AInteger;
  Fnl_fourpp_Specified := True;
end;

function autocompleteRequest.nl_fourpp_Specified(Index: Integer): boolean;
begin
  Result := Fnl_fourpp_Specified;
end;

procedure autocompleteRequest.Setstreetnumber(Index: Integer; const Astring: string);
begin
  Fstreetnumber := Astring;
  Fstreetnumber_Specified := True;
end;

function autocompleteRequest.streetnumber_Specified(Index: Integer): boolean;
begin
  Result := Fstreetnumber_Specified;
end;

procedure Address.Setnl_sixpp(Index: Integer; const Astring: string);
begin
  Fnl_sixpp := Astring;
  Fnl_sixpp_Specified := True;
end;

function Address.nl_sixpp_Specified(Index: Integer): boolean;
begin
  Result := Fnl_sixpp_Specified;
end;

procedure Address.Setnl_fourpp(Index: Integer; const AInteger: Integer);
begin
  Fnl_fourpp := AInteger;
  Fnl_fourpp_Specified := True;
end;

function Address.nl_fourpp_Specified(Index: Integer): boolean;
begin
  Result := Fnl_fourpp_Specified;
end;

procedure Address.Setstreet(Index: Integer; const Astring: string);
begin
  Fstreet := Astring;
  Fstreet_Specified := True;
end;

function Address.street_Specified(Index: Integer): boolean;
begin
  Result := Fstreet_Specified;
end;

procedure Address.Setlat(Index: Integer; const Astring: string);
begin
  Flat := Astring;
  Flat_Specified := True;
end;

function Address.lat_Specified(Index: Integer): boolean;
begin
  Result := Flat_Specified;
end;

procedure Address.Setlng(Index: Integer; const Astring: string);
begin
  Flng := Astring;
  Flng_Specified := True;
end;

function Address.lng_Specified(Index: Integer): boolean;
begin
  Result := Flng_Specified;
end;

procedure Address.Setareacode(Index: Integer; const Astring: string);
begin
  Fareacode := Astring;
  Fareacode_Specified := True;
end;

function Address.areacode_Specified(Index: Integer): boolean;
begin
  Result := Fareacode_Specified;
end;

constructor autocompleteResponse.Create;
begin
  inherited Create;
  FSerializationOptions := [xoLiteralParam];
end;

destructor autocompleteResponse.Destroy;
var
  I: Integer;
begin
  for I := 0 to System.Length(Fresults)-1 do
    SysUtils.FreeAndNil(Fresults[I]);
  System.SetLength(Fresults, 0);
  inherited Destroy;
end;

destructor RangeResult.Destroy;
begin
  SysUtils.FreeAndNil(Flat);
  SysUtils.FreeAndNil(Flng);
  inherited Destroy;
end;

constructor rangeResponse.Create;
begin
  inherited Create;
  FSerializationOptions := [xoLiteralParam];
end;

destructor rangeResponse.Destroy;
var
  I: Integer;
begin
  for I := 0 to System.Length(Fresults)-1 do
    SysUtils.FreeAndNil(Fresults[I]);
  System.SetLength(Fresults, 0);
  inherited Destroy;
end;

initialization
  { Pro6PP_Port }
  InvRegistry.RegisterInterface(TypeInfo(Pro6PP_Port), 'http://api.pro6pp.nl/v1/soap/api.wsdl', 'UTF-8');
  InvRegistry.RegisterDefaultSOAPAction(TypeInfo(Pro6PP_Port), 'http://api.pro6pp.nl/v1/%operationName%');
  InvRegistry.RegisterInvokeOptions(TypeInfo(Pro6PP_Port), ioDocument);
  InvRegistry.RegisterInvokeOptions(TypeInfo(Pro6PP_Port), ioLiteral);
  RemClassRegistry.RegisterXSClass(FeedbackResult, 'http://api.pro6pp.nl/v1/soap/api.wsdl', 'FeedbackResult');
  RemClassRegistry.RegisterXSInfo(TypeInfo(FeedbackResults), 'http://api.pro6pp.nl/v1/soap/api.wsdl', 'FeedbackResults');
  RemClassRegistry.RegisterXSClass(feedbackResponse, 'http://api.pro6pp.nl/v1/soap/api.wsdl', 'feedbackResponse');
  RemClassRegistry.RegisterExternalPropName(TypeInfo(feedbackResponse), 'results', '[ArrayItemName="result"]');
  RemClassRegistry.RegisterSerializeOptions(feedbackResponse, [xoLiteralParam]);
  RemClassRegistry.RegisterXSClass(feedbackRequest, 'http://api.pro6pp.nl/v1/soap/api.wsdl', 'feedbackRequest');
  RemClassRegistry.RegisterSerializeOptions(feedbackRequest, [xoLiteralParam]);
  RemClassRegistry.RegisterXSClass(rangeRequest, 'http://api.pro6pp.nl/v1/soap/api.wsdl', 'rangeRequest');
  RemClassRegistry.RegisterSerializeOptions(rangeRequest, [xoLiteralParam]);
  RemClassRegistry.RegisterXSClass(autocompleteRequest, 'http://api.pro6pp.nl/v1/soap/api.wsdl', 'autocompleteRequest');
  RemClassRegistry.RegisterSerializeOptions(autocompleteRequest, [xoLiteralParam]);
  RemClassRegistry.RegisterXSClass(Address, 'http://api.pro6pp.nl/v1/soap/api.wsdl', 'Address');
  RemClassRegistry.RegisterXSInfo(TypeInfo(Results), 'http://api.pro6pp.nl/v1/soap/api.wsdl', 'Results');
  RemClassRegistry.RegisterXSClass(autocompleteResponse, 'http://api.pro6pp.nl/v1/soap/api.wsdl', 'autocompleteResponse');
  RemClassRegistry.RegisterExternalPropName(TypeInfo(autocompleteResponse), 'results', '[ArrayItemName="result"]');
  RemClassRegistry.RegisterSerializeOptions(autocompleteResponse, [xoLiteralParam]);
  RemClassRegistry.RegisterXSClass(RangeResult, 'http://api.pro6pp.nl/v1/soap/api.wsdl', 'RangeResult');
  RemClassRegistry.RegisterXSInfo(TypeInfo(RangeResults), 'http://api.pro6pp.nl/v1/soap/api.wsdl', 'RangeResults');
  RemClassRegistry.RegisterXSClass(rangeResponse, 'http://api.pro6pp.nl/v1/soap/api.wsdl', 'rangeResponse');
  RemClassRegistry.RegisterExternalPropName(TypeInfo(rangeResponse), 'results', '[ArrayItemName="result"]');
  RemClassRegistry.RegisterSerializeOptions(rangeResponse, [xoLiteralParam]);

end.